/*****************************************************************************
 *
 * proxjs-x-menu.js -- inline script for sidki's Proxomitron config
 *
 * This script gets injected via XMLHttpRequest once you left-click on a page
 * element that isn't a link.  Unless you've unticked "Add Proxomitron Menu"
 * in the Web Filters Config Control section.  There's also a fall-back for
 * older browsers, where it gets inserted as external script.
 *
 * Last edited: 2009-07-13
 *
 *****************************************************************************/

/* ====================================
   Write the menu.
   ==================================== */

(function () {
  var x = [], here = window.location, url = prxO.oAss.asUesc(prxO.oMen.meSet[8]),
  hostA = url.match(/:\/\/([^\/]+)/)[1], path, base, pMode;

  // Location parsing
  if (here.protocol.match(/^(about|keyword):/)) {
    var urlA = url.match(/^([^:]+:\/\/[^\/]+)(\/([^\/?]+\/)*)/);
    path = urlA[0];
    base = urlA[1];
  } else {
    base = here.protocol; base += "//"; base += here.host;
    path = base; path += here.pathname;
  }

  // Element counts
  var hasJS = prxO.oInt.inGetEl("script").length, hasCSS = 0, i, iObj, iTag,
  aCSS = document.styleSheets;
  if (aCSS) {
    if (prxO.oSet.$_level >= 5) hasCSS = aCSS.length;
    else
      for (i = 0; i < aCSS.length; i++) {
        iObj = aCSS[i];
        iTag = iObj.owningElement || iObj.ownerNode;
        if (iTag && iTag.lang != "x-prox-css") hasCSS++;
      }
  }

  // Headings
  var seeName = (typeof window.name != "string") ? "Something's odd!" :
    (seeName = window.name) ? seeName.match(/^(.{1,15}).*/)[1].replace(/</, "&lt;") : "Dynamic";
  var seeSize = (typeof document.fileSize == "string") ? document.fileSize + " bytes" : "Navigate";
  var seeMode = prxO.oAss.asMode;
  if (seeMode == "BackCompat") seeMode = "Quirks Mode";
  else if (document.doctype && (pMode = document.doctype.publicId)) {
    pMode = pMode.match(/ (.)([^/]+?(?=itional| plus|\/|$))/);
    if (pMode)
      seeMode = prxO.oSet.$_xns ?
        "<b class=\"Pr0xM-B\">" + pMode[1] + pMode[2] + "</b>" : pMode[1] + pMode[2];
  }
  else
    seeMode = prxO.oSet.$_xns ? "XHTML + XML" : (seeMode == "CSS1Compat") ?
      prxO.oSet.$_xml ? "(X)HTML Mode" : "Standards Mode" : seeMode;

  // Common strings
  var beAnc = "\n<div class=\"Pr0xMCnt-Div\"><a class=\"Pr0xMLink\" target=\"";
  var beTarg = (prxO.oMen.meSet[0] == 2) ? "_blank" : "_top";
  var beSelect = beAnc; beSelect += "_self\" href=\"javascript://\" onclick=\"return false;\" onmousedown=\"var q = window.getSelection || document.getSelection; q = '' + (q ? q() : document.selection.createRange().text); q = q || prompt('No text selected. &#160;Enter hostname or leave empty for current host:', ''); if (q == '' || (q == null &amp;&amp; parent.frames.length > 0)) q = '";
  beSelect += hostA; beSelect += "'; if (q != null) ";
  var beCheck = beAnc; beCheck += "_self\"><label class=\"Pr0xMLink\"><input class=\"Pr0xMLink\" type=\"checkbox\" value=";

  function doLib(f, m, n) { return (
    beAnc + "_self\" href=\"javascript:prxO.oMen.meLib." + f + "();\">" + m +
    " &#" + (n || "8756") + "; </a></div>"
  ); }

  function doNavi(t, l) { return (
    t ? beAnc + "_top\" href=\"" + t + "\">" + l + " </a></div>" : ""
  ); }

  function doUrlCom(m) { return (
    beAnc + beTarg + "\" href=\"" + path + doAmp(here.search) + "?prx-command=" +
    m + ".." + here.hash + "\">" + m + " </a></div>"
  ); }

  function doRadio(n, m) { return (
    beAnc + "_self\"><label class=\"Pr0xMLink\"><input class=\"Pr0xMLink\" " +
    "type=\"radio\" name=\"pr0xMMode\" " +
    ((n == Math.floor(prxO.oSet.$_level)) ? "checked=\"checked\" " : "") +
    "value=\"i_level:" + n + "\"" + prxO.oSet.$_xml + ">" + m +
    " Mode</label> </a></div>"
  ); }

  function doAllow(a, b) {
    return beCheck + "\"" + a + "\"" + prxO.oSet.$_xml + ">" + b + "</label> </a></div>";
  }

  function doCfg(n, m, a, b, c, d) {
    var st = prxO.oMen.meSet[n];
    return (
      beCheck + "\"i_" + m + ":" + (st ? "-" : "") +
      "1\"" + prxO.oSet.$_xml + "><b class=\"Pr0xM-B\">" + (st ? a : b) + "</b> " +
      (st ? c : d || c) + "</label> </a></div>"
    );
  }

  function doInput(a, b) {
    return "\n<input" + a + " class=\"Pr0xM-Input\" type=\"button\" name=\"" +
      b + "\" value=\"" + b + "\" onclick=\"prxO.oMen.meLib.mlForm(this);\"" +
      prxO.oSet.$_xml + ">";
  }

  function doAmp(m) { return m.replace(prxO.oAss.asReAmp, "&amp;"); }

  x[x.length] = "\n<table id=\"pr0xM-Table\" onmouseover=\"clearTimeout(prxO.oMen.meTimer);\" onmouseout=\"prxO.oMen.meHide();\"><tbody><tr>";

  x[x.length] = "\n<td class=\"Pr0xM-L-Td\">";
  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">"; x[x.length] = seeName; x[x.length] = "</div>";
  x[x.length] = beAnc; x[x.length] = "_self\" href=\"javascript:prxO.oInt.inToggleB('Pr0x','cl','span');\">Toggle Kills &#8756; </a></div>";
  x[x.length] = doLib("mlTComment", "Toggle Comments");
  x[x.length] = (hasCSS ? doLib("mlTStyle", "Toggle CSS") : "");
  x[x.length] = doLib("mlDparent", "Toggle DOM Path");
  x[x.length] = doLib("mlTopo", "Toggle Topo View");
  x[x.length] = beAnc; x[x.length] = "_self\" href=\"javascript:(function(){for(var%20i=0;i%3c10000;i++){window.clearInterval(i);window.clearTimeout(i)}})();\">Kill Timers &#8756; </a></div>";

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">"; x[x.length] = seeMode; x[x.length] = "</div>";
  x[x.length] = (hasJS ? doLib("mlScripts", "Show " + hasJS + " Script" + ((hasJS > 1) ? "s" : "")) : "");
  x[x.length] = (hasCSS ? doLib("mlCSS", "Show " + hasCSS + " CSS") : "");
  x[x.length] = beAnc; x[x.length] = "_self\" href=\"javascript:void(prxO.oInt.inMyPop('"; x[x.length] = here.protocol + "//" + document.domain; x[x.length] = "/local.ptron/sidki_h_"; x[x.length] = prxO.oSet.$_cfg; x[x.length] = "/shell.html',',width=676,height='+screen.height*.6));\">JavaScript Shell &#8756; </a></div>";
  x[x.length] = (!prxO.oiIsIE ? doLib("mlJSvars", "JS Variables") : "");
  x[x.length] = doLib("mlIDs", "Classes &amp; IDs");
  x[x.length] = doLib("mlDocProps", "Doc Properties");
  x[x.length] = doLib("mlDynSrc", "DOM Source", "187");

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">"; x[x.length] = prxO.oSet.$_cfg; x[x.length] = "</div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://pgl.yoyo.org/adservers/serverlist.php?hostformat=hosts&amp;showintro=0\">Verify Ad Lists </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://sidki.proxfilter.net/prox-down.html\">Config Updates </a></div>";

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">Translate</div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://translate.google.com/translate_c?langpair=auto|en&amp;u="; x[x.length] = encodeURIComponent(url); x[x.length] = "\">Google: automatic </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://www.microsofttranslator.com/BV.aspx?from=auto&amp;to=en&amp;a="; x[x.length] = encodeURIComponent(url); x[x.length] = "\">Bing: automatic </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://www.tranexp.com:2000/Translate/index.shtml?type=url&amp;url="; x[x.length] = encodeURIComponent(url); x[x.length] = "\">InterTran: choose </a></div>";

  x[x.length] = "\n</td><td class=\"Pr0xM-L-Td\">";
  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">"; x[x.length] = seeSize; x[x.length] = "</div>";
  x[x.length] = doNavi(prxO.oMen.meSet[5], "Top"); x[x.length] = doNavi(prxO.oMen.meSet[6], "Up");
  x[x.length] = doNavi(doAmp(document.referrer), "Referrer");

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">Prox</div>";
  x[x.length] = doUrlCom("src"); x[x.length] = doUrlCom("src..bweb"); x[x.length] = doUrlCom("dbug"); x[x.length] = doUrlCom("bweb"); x[x.length] = doUrlCom("bypass");

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">Site</div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://validator.w3.org/check?uri="; x[x.length] = encodeURIComponent(url); x[x.length] = "&amp;ss=1&amp;sp=1&amp;noatt=1&amp;verbose=1\">Validate </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://uptime.netcraft.com/up/graph/?host="; x[x.length] = hostA; x[x.length] = "\">Netcraft </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://www.google.com/search?q=cache:"; x[x.length] = encodeURIComponent(url); x[x.length] = "\">Cached </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://web.archive.org/web/*/"; x[x.length] = doAmp(url); x[x.length] = "\">Way Back </a></div>";
  x[x.length] = beAnc; x[x.length] = beTarg; x[x.length] = "\" href=\"http://www.alexa.com/data/details/main?url="; x[x.length] = doAmp(url); x[x.length] = "\">Alexa </a></div>";
  x[x.length] = beAnc; x[x.length] = "_self\" href=\"javascript:void(prxO.oInt.inMyPop('http://bugmenot.com/view/'+escape(&quot;"; x[x.length] = hostA; x[x.length] = "&quot;),',width=485,height=390'));\">BugMeNot &#8756; </a></div>";

  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">Host or IP</div>";
  x[x.length] = beSelect; x[x.length] = "(function () { var d = prxO.oInt.inMyPop('', ',width=350,height=350').document; d.write('&lt;html>&lt;head>&lt;title>All Net Tools - Loading...&lt;/title>&lt;/head>&lt;body>&lt;form name=pform method=POST action=http://www.all-nettools.com/toolbox/smart-whois.php?prx-keyword=.s_flag.>&lt;input name=ip type=hidden value=' + escape(q) + '>&lt;/form>&lt;script>window.setTimeout(&quot;document.pform.submit()&quot;,300);&lt;/script>&lt;/body>&lt;/html>'); d.close(); })(); void 0;\">SmartWhois &#8756; </a></div>";
  x[x.length] = beSelect; x[x.length] = "prxO.oInt.inMyPop('http://samspade.org/whois?query=' + escape(q) + ';server=auto');\">Whois &#187; </a></div>";
  x[x.length] = beSelect; x[x.length] = "prxO.oInt.inMyPop('http://www.geobytes.com/iplocator.htm?getlocation&amp;ipaddress=' + escape(q));\">Location &#187; </a></div>";

  x[x.length] = "\n</td><td id=\"pr0xM-R-Td\">";
  x[x.length] = "\n<div class=\"Pr0xMSep-Div\">Allow</div>";
  x[x.length] = "\n<form class=\"Pr0xMLink\" action=\"\">";
  x[x.length] = doAllow("a_js", "All JavaScript");
  x[x.length] = doAllow("a_ads", "All Ads");
  x[x.length] = doAllow("a_adban.a_adimg", "Ad Banners");
  x[x.length] = doAllow("a_adcomm1.a_adcomm2", "Ad Comments");
  x[x.length] = doAllow("a_adcont.a_adtab.a_adform.a_adcss", "Ad Containers");
  x[x.length] = doAllow("a_adjs", "Ad JavaScript");
  x[x.length] = doAllow("a_track.a_redir", "Trackers &amp; Redir");
  x[x.length] = doAllow("a_rdlink.a_jslink", "Redir- &amp; JS-Links");
  x[x.length] = doAllow("a_flash.a_embed", "Flash &amp; Media");
  x[x.length] = doAllow("i_ua:0.a_refer", "UA &amp; Referrer");
  x[x.length] = "\n<div class=\"Pr0xMSep-Div\"></div>";
  x[x.length] = doCfg(1, "layout", "Alter", "Keep", "Layout");
  x[x.length] = doCfg(2, "script", "Allow", "Block", "Scripts");
  x[x.length] = doCfg(3, "proxy", "No", "Use", "Proxy");
  x[x.length] = doCfg(4, "spoof", "Don't", "Spoof", "spoof IP", "IP");
  x[x.length] = "\n<div class=\"Pr0xMSep-Div\"></div>";
  x[x.length] = doRadio(5, "Debug"); x[x.length] = doRadio(4, "Advanced");
  x[x.length] = doRadio(3, "Standard"); x[x.length] = doRadio(2, "Light");
  x[x.length] = doRadio(1, "Minimal");
  x[x.length] = "\n<div id=\"pr0xMBut-Div\">";
  x[x.length] = doInput(" id=\"pr0xM-Go\"", "Go");
  x[x.length] = doInput(" style=\"width:49px\"", "Session");
  x[x.length] = doInput(" style=\"width:26px\"", "List");
  x[x.length] = "\n</div></form>\n</td>";

  x[x.length] = "</tr></tbody></table>";

  prxO.oMen.meDiv.innerHTML = x.join("");
  if (prxO.oSet.$_level < 5) delete prxO.oMen.meSet;
  PrxRLsetTimeout(function () { prxO.oBody.appendChild(prxO.oMen.meDiv); }, 0);
}) ();

/* ====================================
   Function library used by the menu items.
   ==================================== */

prxO.oMen.meLib = {

  // Calls menu popups in one of two ways, in order to circumvent same origin
  // policies in current browsers. - sidki
  mlPopDo : function (aPop, aTit) {
      var cTop = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" " +
        "\"http://www.w3.org/TR/html4/loose.dtd\">\n<html>\n<head>\n<title>" + aTit +
        "</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n" +
        "<style type=\"text/css\">\n" +
        "body {font:12px/20px Verdana,Arial,sans-serif;color:#313131;background:#CEDFEF;}\n" +
        "h2 {font-size:18px;}\nh4 {margin:22px 0 6px 0;font-size:12px;}\n" +
        "pre {white-space:pre-wrap;}\n</style>\n" +
        "<style type=\"text/css\">\n" + this.mlPopCSS + "\n</style>\n" +
        "<!--[if IE]>\n<style type=\"text/css\">\n" +
        "body {word-wrap:break-word;}\n</style>\n<script type=\"text/javascript\">//<![CDATA[\n" +
        "window.onload = function () {\n  var fA = document.getElementsByTagName(\"iframe\");\n" +
        "  for (var i = 0, fI; fI = fA[i]; i++)\n" +
        "    try { fI.contentWindow.document.body.style.background = \"#DDEEFE\"; } catch (er) {}\n" +
        "};\n//]]></script>\n" +
        "<![endif]-->\n</head>\n<body>\n",
      cBot = "\n</body>\n</html>\n", planB;

      try {
        aPop.document.open();
        try { aPop.document.write(cTop + this.mlPopCont + cBot); }
        catch (er) { planB = true; }
        aPop.document.close();
      }
      catch (er) { planB = true; }
      if (planB)
        aPop.location.replace(location.protocol + "//" + document.domain +
          "/local.ptron/sidki_h_" + prxO.oSet.$_cfg + "/info-pop.html");
  },

  // Toggle comments: Shows/hides content of comment-blocks
  // and commented-out code. - sidki
  mlTComment : function () {
    var i, it, ceci = arguments.callee;

    function walk(node) {
      var i, kids, child, tag;

      function swap(xpath) {
        var tname, targ = child.nodeValue;
        if (prxO.oSet.$_level >= 5 || targ.indexOf(" PROX") != 0) {
          tag = prxO.oInt.inMakeEl("div");
          tag.className = "Pr0x Pr0xHTag";
          targ = targ.replace(/&(?!amp;)/g, "&amp;");
          targ = targ.replace(/<(\/?script)/gi, "&lt;$1");
          tag.innerHTML = "&lt;!--" + targ + "--&gt;";
          tname = xpath ? child.parentNode.tagName : node.tagName;
          if (tname == "HEAD" || tname == "head") {
            if (!ceci.hdColl) {
              ceci.hdColl = prxO.oInt.inMakeEl("div");
              prxO.oInt.inSetCSS(ceci.hdColl,
                "position: relative; z-index: 10000; padding: 12px; " +
                "background-color: #DDEEFE; border: 1px dashed black;");
            }
            ceci.hdColl.appendChild(tag);
          } else ceci.bdColl[ceci.bdColl.length] = [tag, child];
        }
      }

      if (prxO.oiXpath) {
        kids = document.evaluate("//comment()", document, null, 0, null);
        while ((child = kids.iterateNext())) swap(1);
      } else {
        kids = node.childNodes;
        for (i = 0; child = kids[i]; i++) {
          if (child.nodeName == "#comment") swap();

          // IE6 dupes the BODY node to BASE, if present!
          else if (child.tagName != "BASE") walk(child);
        }
      }
    }

    if (ceci.done) {
      if (ceci.hdColl) {
        prxO.oBody.removeChild(ceci.hdColl);
        delete ceci.hdColl;
      }
      for (i = 0; it = ceci.bdColl[i]; i++) it[0].parentNode.removeChild(it[0]);
      delete ceci.bdColl;
    } else {
      ceci.bdColl = []; walk(document);
      if (ceci.hdColl)
        prxO.oBody.insertBefore(ceci.hdColl, prxO.oBody.firstChild);
      for (i = 0; it = ceci.bdColl[i]; i++)
        it[1].parentNode.insertBefore(it[0], it[1]);
    }
    ceci.done = !ceci.done;
  },

  // Toggle topographic view: Shows the nesting level of every element using
  // shading. - Jesse Ruderman, Joseph Pearson, sidki
  mlTopo : function () {
    var C = arguments.callee;
    if (C.done) {
      C.css.disabled = true;
      prxO.oInt.inGetEl("head")[0].removeChild(C.css.owningElement || C.css);
    } else {
      var s = "body", c = "", I = "!important;", i, b, f, x, h;
      for (i = 0; i < 17; ++i) {
        x = i.toString(16);
        b = i > 15 ? "FFCCCC" : x + x + x;
        f = i > 9 ? "000000" : "FFFFFF";
        c += s + "{background:#" + b + I + "border-color:#" + b + I + "color:#" + f + I + "}\n";
        s += " *";
      }
      if (typeof document.createStyleSheet == "object") {
        C.css = document.createStyleSheet();
        C.css.cssText = c;
      } else {
        C.css = prxO.oInt.inMakeEl("link");
        C.css.id = "pr0xTtopo";
        C.css.rel = "stylesheet";
        C.css.href = "data:text/css," + escape(c);
        prxO.oInt.inGetEl("head")[0].appendChild(C.css);
      }
    }
    return void (C.done = !C.done);
  },

  // Toggle DOM path: Lists the ancestors of any element you hover over in
  // the status bar. - Jesse Ruderman, sidki
  mlDparent : function () {
    var ceci = arguments.callee;
    if (ceci._toggle) {
      window.defaultStatus = ceci._toggle;
      ceci._toggle = 0;
      prxO.oInt.inEventRem(document, "mouseover", ceci._over);
      return;
    }

    ceci._toggle = window.defaultStatus;
    ceci._over = function (e) {
      e = e || window.event;
      var s, g = e.target || e.srcElement;
      try { s = A(g, ""); }
      catch (er) { s = er.message; }
      if (s.length > 70) {
        s = s.substr(s.length - 70);
        s = "..." + s.substr(s.indexOf(">"))
      }
      window.defaultStatus = s + "";
      return true;
    };

    function A(n, g) {
      var p = n.parentNode, t = n.tagName, x, y;
      if (!p) return "";
      for (y = 0, x = n.previousSibling; x; x = x.previousSibling)
        if (x.nodeName == n.nodeName) y++;
      if (!t) return A(p, g);
      var T = t.toUpperCase(), b = (T != "TABLE" &&
        T != "TBODY" && T != "THEAD" && T != "TR"), c = n.className, i = n.id;
      return A(p, " > ") + (b ? T : T.toLowerCase()) + (y ? "[" + (y + 1) + "]" : "") +
        (c ? "." + c : "") + (i ? "#" + i : "") + (b ? g : " ");
    }

    prxO.oInt.inEventAdd(document, "mouseover", ceci._over);
    window.defaultStatus = A(document.documentElement, "");
  },

  // Toggle stylesheets. - sidki, Jesse Ruderman
  mlTStyle : function () {
    var h, i, d, j = 0, o, x = document.styleSheets;
    for (i = 0; i < x.length; i++) {
      d = x[i];
      if (d.disabled) d.disabled = 0;
      else {
        o = d.owningElement || d.ownerNode; h = d.href;
        if (o && o.lang != "x-prox-css") {
          d.disabled = 1;
          if (!arguments.callee.done)
            prxO.oInt.inFooter(3, "style " + ++j, (o.tagName == "STYLE") ? "inline" : h);
        }
      }
    }
    arguments.callee.done = true;
  },

  // Show all JavaScript variables and functions. - Jesse Ruderman
  mlJSvars : function () {
    var i, bVal, bStr, bTit = "All JS Variables and Functions",
    bRex = prxO.oiIsOp ? /^[Pp]rx|^pr0x/ : /^[Pp]rx|^onerror/,
    bPop = prxO.oInt.inMyPop("", ",width=600,height=400"),
    bCont = "\n<span id=\"t-itle\" style=\"display:none\">" +
      bTit + "</span>\n<table border=\"1\" summary=\"\">\n<thead><tr><th>" +
      "Variable</th><th>Type</th><th class=\"string\">Value as string</th></tr></thead>\n";
    this.mlPopCSS = "table,td,th {border:1px solid #91BBE3;}\n" +
      "td,th {font-size:12px;line-height:17px;}\nth.string {text-align:left;padding-left:100px;}\n" +
      "div.er {color:red;}";

    function htmlEsc(s) {
      return s.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;");
    }

    for (i in window)
      if (!(i in bPop) && (!bRex.test(i) || prxO.oSet.$_level >= 5)) {
        bCont += "<tr><td valign=\"top\">" + htmlEsc(i) +
          "</td><td valign=\"top\">" + htmlEsc(typeof window[i]) +
          "</td><td valign=\"top\">";
        if ((bVal = window[i]) === null) bCont += "null";
        else if (bVal === undefined) bCont += "undefined";
        else
          try {
            bStr = String(bVal);
            bCont += bStr.length ? htmlEsc(bStr) : "\xA0";
          } catch (er) {
            bCont += "<div class=\"er\">" + htmlEsc(String(er)) + "</div>\n";
          }
        bCont += "</td></tr>\n";
      }

    bCont += "</table>\n";
    this.mlPopCont = bCont;
    this.mlPopDo(bPop, bTit);
  },

  // Show all classes and IDs used in the document. - Jesse Ruderman, sidki
  mlIDs : function () {
    var i, bTit = "All Classes and IDs", clO = {}, idO = {}, clA = [], idA = [],
    pxC, pxI, pxCs, pxIs, pxT, pxB, pxA = prxO.oInt.inGetEl("*"),
    bCont = "\n<span id=\"t-itle\" style=\"display:none\">" +
      bTit + "</span>\n<table border=1 summary=\"\">\n<thead><tr><th>#</th>" +
      "<th>Tag</th><th>className</th></tr></thead>\n";
    this.mlPopCSS = "table {float:left;margin-right:8px;}\n" +
      "table,td,th {border:1px solid #91BBE3;}\ntd,th {font-size:12px;line-height:17px;}";

    for (i = 0; pxT = pxA[i]; i++) {
      pxC = pxT.className;
      if (pxC && (prxO.oSet.$_level >= 5 || pxC.indexOf("Pr0x") != 0)) {
        pxCs = pxT.tagName; pxCs += "$*,"; pxCs += pxC;
        clO[pxCs] = clO[pxCs] ? ++clO[pxCs] : 1;
      }
      pxI = pxT.id;
      if (pxI && typeof pxI == "string" && (prxO.oSet.$_level >= 5 || pxI.indexOf("pr0x") != 0)) {
        pxIs = pxT.tagName; pxIs += "$*,"; pxIs += pxI;
        idO[pxIs] = idO[pxIs] ? ++idO[pxIs] : 1;
      }
    }

    for (pxCs in clO) if (!isNaN(clO[pxCs])) clA[clA.length] = [pxCs, clO[pxCs]];
    clA.sort();
    for (i = 0; pxB = clA[i]; i++)
      bCont += "<tr><td>" + pxB[1] + "</td><td>" + pxB[0].split("$*,").join("</td><td>") + "</td></tr>\n";
    bCont += "</table>\n";
    bCont += "<table border=1 summary=\"\">\n<thead><tr><th>#</th><th>Tag</th><th>ID</th></tr></thead>\n";
    for (pxIs in idO) if (!isNaN(idO[pxIs])) idA[idA.length] = [pxIs, idO[pxIs]];
    idA.sort();
    for (i = 0; pxB = idA[i]; i++)
      bCont += "<tr><td>" + pxB[1] + "</td><td>" + pxB[0].split("$*,").join("</td><td>") + "</td></tr>\n";

    bCont += "</table>\n";
    this.mlPopCont = bCont;
    this.mlPopDo(prxO.oInt.inMyPop("", ",width=520,height=500"), bTit);
  },

  // Show linked and embedded scripts.  Proxomitron's standard scripts are
  // not displayed. - Jesse Ruderman, sidki
  mlScripts : function () {
    var bTit = "Scripts in " + location.href.replace(prxO.oAss.asReAmp, "&amp;"),
    bCont = "\n<h2 id=\"t-itle\">" + bTit + "</h2>\n",
    i, si, ifr, r_src, b_for, blk, s = prxO.oInt.inGetEl("script"),
    rgx = prxO.oiIsIE ? /\.(js|vbs)(\b)/gi : prxO.oiIsMoz ? /\.(dll|json|vbs)(\b)/gi : null;
    this.mlPopCSS = "body {margin:18px;}\npre {margin:4px 0 4px 0;}\n" +
      "iframe {width:100%;height:27em;border:1px solid;background:#DDEEFE;}";

    function trim(s) {
      return s.replace(/^\s+\n/, "").replace(/\s+$/, "")
        .replace(prxO.oAss.asReAmp, "&amp;")
        .replace(/</g, "&lt;").replace(/>/g, "&gt;") || "&#160;";
    }

    function query(s) {
      r_src = r_src.replace(/^\s+/, "").replace(/\s+$/, "");
      if (s) r_src = r_src.replace(rgx, ".$1prox.htm$2");
      var anc = r_src.indexOf("#"), que = "?prx-sniff:proxov&amp;prx-ref:";
      if (anc != -1) r_src = r_src.substring(0, anc) + que + r_src.substr(anc);
      else r_src += que;
    }

    for (i = 0; si = s[i]; i++) {
      r_src = si.src; blk = "";
      if (r_src) {
        if (r_src.search(/\/dummy.js|prxCountAd|void%200/) != -1) {
          if ((b_for = si.charset)) {
            r_src = b_for;
            blk = "Blocked ";
          } else {
            r_src = "";
            bCont += "<h4>Blocked inline script</h4><pre>" + trim(si.text) + "</pre>\n";
          }
        }
        if (r_src) {
          r_src = r_src.replace(prxO.oAss.asReAmp, "&amp;");
          bCont += '<h4>' + blk + 'script src="' + r_src + '"</h4>\n';
          if (prxO.oiIsIE) {
            if (r_src.indexOf("?prx-sniff:") != -1 || r_src == "//:") continue;
            query(1);
          }
          else if (prxO.oiIsMoz && rgx.test(r_src)) query(1);
          else if (blk) query();
          bCont += '<iframe src="' + r_src + '"></iframe>\n';
        }
      }
      else bCont += "<h4>Inline script</h4><pre>" + trim(si.text) + "</pre>\n";
    }

    this.mlPopCont = bCont;
    this.mlPopDo(prxO.oInt.inMyPop("", ",width=800,height=" + screen.height * .7), bTit);
  },

  // Show linked, embedded, imported style sheets.  Proxomitron's standard CSS
  // is not displayed. - Jesse Ruderman, ddandyy, sidki
  mlCSS : function () {
    var bTit = "Style Sheets in " + location.href.replace(prxO.oAss.asReAmp, "&amp;"),
    bCont = "\n<h2 id=\"t-itle\">" + bTit + "</h2>\n";
    this.mlPopCSS = "body {margin:18px;}\npre {margin:4px 0 4px 0;}\n" +
      "iframe {width:100%;height:27em;border:1px solid;background:#DDEEFE;}";

    function trim(aStr) {
      return aStr.replace(/^\s*\n/, "").replace(/\s*$/, "")
        .replace(prxO.oAss.asReAmp, "&amp;")
        .replace(/</g, "&lt;").replace(/>/g, "&gt;")
        .replace(/}(?![\r\n])/g, "}\n") || "&#160;";
    }

    function queryIE(aUrl, aLevel) {
      aUrl = aUrl.replace(/^\s*/, "").replace(/\s*$/, "");
      var rgx = /\.(css)(\b)/gi;
      if (aLevel) {
        var bHref = location.href, bQr, bRex = aUrl.search(/^(?:https?:)?\/(\/)?/i);
        if (bRex == -1) {
          bQr = bHref.substr(0, bHref.indexOf("?")) || bHref;
          aUrl = bHref.substr(0, bQr.lastIndexOf("/") + 1) + aUrl;
        } else if (bRex == 0 && bHref.indexOf("://") > 0 && !RegExp.$1)
          aUrl = bHref.substr(0, bHref.substr(8).indexOf("/") + 8) + aUrl;
      }
      aUrl = aUrl.replace(rgx, ".$1prox.htm$2");
      var anc = aUrl.indexOf("#"), que = "?prx-sniff:proxov&amp;prx-ref:";
      if (anc != -1) aUrl = aUrl.substring(0, anc) + que + aUrl.substr(anc);
      else aUrl += que;
      return aUrl;
    }

    function testImp(aRule, aLevel) {
      var i, r_rul;
      if (aRule.imports)
        for (i = 0; i < aRule.imports.length; i++)
          fetchImp(aRule.imports[i], aLevel);
      else {
        try { r_rul = aRule.cssRules; } catch (er) { r_rul = ""; }
        for (i = 0; i < r_rul.length; i++)
          fetchImp(r_rul[i], aLevel);
      }
    }

    function fetchImp(bRule, aLevel) {
      var aImp = bRule.href;
      if (!aImp) return;
      var r_lev = aLevel ? "Import imported" : "Imported";
      r_lev = dis ? r_lev.toLowerCase() : r_lev;
      bCont += '<h4>' + dis + r_lev + ' CSS' + ' href="' + aImp + '"</h4>\n';
      var bHref = bRule.parentStyleSheet.href, bRex, bQr;
      if (bHref) bRex = aImp.search(/^(?:https?:)?\/(\/)?/i);
      if (bRex == -1) {
        bQr = bHref.substr(0, bHref.indexOf("?")) || bHref;
        aImp = bHref.substr(0, bQr.lastIndexOf("/") + 1) + aImp;
      } else if (bRex == 0 && bHref.indexOf("://") > 0 && !RegExp.$1)
        aImp = bHref.substr(0, bHref.substr(8).indexOf("/") + 8) + aImp;
      if (prxO.oiIsIE) aImp = queryIE(aImp, aLevel);
      bCont += '<iframe src="' + aImp + '"></iframe>\n';
      testImp(bRule.styleSheet || bRule, 1);
    }

    var sty = document.styleSheets, sti, r_src, dis, r_tag, r_txt, r_name;
    for (var i = 0; i < sty.length; i++) {
      sti = sty[i];
      r_tag = sti.ownerNode || sti.owningElement;
      if (prxO.oSet.$_level < 5 && r_tag && r_tag.lang == "x-prox-css") continue;
      dis = (sti.title == "ProxBlockedCSS") ? "Blocked " : sti.disabled ? "Disabled " : "";
      if (typeof sti.href != "string" ||
        (r_tag && r_tag.tagName == "STYLE")) {
        r_txt = (typeof sti.cssText == "string") ? sti.cssText : r_tag ? r_tag.innerHTML : "";
        bCont += "<h4>Inline style</h4>\n<pre>" + trim(r_txt) + "</pre>\n";
      } else {
        r_src = sti.href;
        r_name = (r_tag && (r_name = r_tag.nodeName)) ? r_name.toLowerCase() : "link";
        if (r_src) r_src = r_src.replace(prxO.oAss.asReAmp, "&amp;");
        bCont += '<h4>' + dis + r_name + ' href="' + r_src + '"</h4>\n';
        if (!r_src) continue;
        if (prxO.oiIsIE) r_src = queryIE(r_src);
        bCont += '<iframe src="' + r_src + '"></iframe>\n';
      }
      testImp(sti);
    }

    this.mlPopCont = bCont;
    this.mlPopDo(prxO.oInt.inMyPop("", ",width=800,height=" + screen.height * .7), bTit);
  },

  // Show DOM source: Displays the DOM tree of the page as HTML.
  // - Jesse Ruderman, sidki
  mlDynSrc : function () {

    function hiLight(s) {
      function doSpecial(aStr, aSub1, aSub2, aSub3, aSub4) {
        if (aSub1 && aSub1.indexOf("!") == 0)
          return '#_pxO_span class="c"#_pxC_<' + aSub1 + "#_pxO_/span#_pxC_";
        else
          return "<" + aSub2 + '#_pxO_span class="d"#_pxC_' + aSub4 + "#_pxO_/span#_pxC_";
      }

      function doTag(aStr, aSub1) {
        var bStyle = (aSub1.search(/\/?(?:!doctype|html|head|title|body)/i) == 0) ? "e" : "t";
        aSub1 = aSub1.replace(/(\s|\n)([a-zA-Z][^\s=<(){}]*\s?=\s?)("[^"\n]*"|'[^'\n]*'|[^<>\s\n]*)/g,
          '$1#_pxO_b class="i"#_pxC_$2#_pxO_/b#_pxC_#_pxO_b class="q"#_pxC_$3#_pxO_/b#_pxC_');
        return '#_pxO_b class="' + bStyle + '"#_pxC_<' + aSub1 + "#_pxO_/b#_pxC_";
      }

      function doEntity(aStr) {
        switch (aStr) {
          case "&"      : return "&amp;";
          case "<"      : return "&lt;";
          case ">"      : return "&gt;";
          case "#_pxO_" : return "<";
          case "#_pxC_" : return ">";

          // Turn high ASCII chars into entities.
          default :
            aStr = escape(aStr).toLowerCase();
            aStr = (aStr.indexOf("u") == 1) ? aStr.substr(2) : aStr.substr(1);
            return "&amp;#x" + aStr + ";";
        }
      }

      s = s.replace(/<((?:[a-zA-Z][a-zA-Z0-9]*|!DOCTYPE)[^<>]*>|\/[^->]+>)/g, doTag);
      s = s.replace(/<(?:(!--(?:.|\r|\n)*?-- ?>)|((script|SCRIPT|style|STYLE)(?:[^>]+?[^/]>|>)(?:#_pxO_[a-z/"= ]+#_pxC_))(?![\s|\r|\n]*(?:#_pxO_[a-z/"= ]+#_pxC_)<[^!])((?:.|\r|\n)+?)(?=(?:#_pxO_[a-z/"= ]+#_pxC_)<\/\3))/g,
        doSpecial);
      s = s.replace(/[&<>\u007f-\u9999]|#_px._/g, doEntity);
      return s;
    }

    function outer(t) {
      var dtObj = document.doctype, dtStr = "";
      if (dtObj) {
        var dtNam = dtObj.name, dtPub = dtObj.publicId, dtSys = dtObj.systemId;
        dtStr = "<!DOCTYPE" +
          (dtNam ? " " + dtNam : "") +
          (dtPub ? " PUBLIC \"" + dtPub + "\"" : "") +
          (dtSys ? " \"" + dtSys + "\"" : "") + ">\n";
      }

      if (t.outerHTML) return dtStr + t.outerHTML;
      var cAtt = t.attributes, htStr = "<" + t.tagName, i = 0, iAtt;
      for (; iAtt = cAtt[i]; i++)
        htStr += " " + iAtt.name + "=\"" + iAtt.value + "\"";
      return dtStr + htStr + ">\n" + t.innerHTML + "\n</" + t.tagName + ">";
    }

    var bTit = "Dynamic Source";
    this.mlPopCSS = "@import url(http://local.ptron/ViewSrc.css);" +
      "span.c,span.c *{color:gray;}span.d,span.d *{color:darkgoldenrod;}";
    this.mlPopCont = "\n<pre id=\"t-itle\" title=\"" + bTit + "\"></pre><pre>\n\n" +
      hiLight(outer(document.documentElement)) + "\n</pre>\n";
    this.mlPopDo(prxO.oInt.inMyPop(""), bTit);
  },

  // Get various information about the currently displayed document.
  // - Paul Rupe
  mlDocProps : function () {
    var i, j, imI, liI, imC = 0, liC = 0, imO = document.images, liO = document.links,
    al = (prxO.oSet.$toDo & 4) ? PrxRLalert : alert;
    for (i = 0; imI = imO[i]; i++)
      if (imI.className.indexOf("Pr0x") == 0 || imI.id.indexOf("pr0x") == 0) imC++;
    for (j = 0; liI = liO[j]; j++)
      if (liI.className.indexOf("Pr0x") == 0) liC++;
    al(
      "Window name: " +  (window.name || "none") +
      "\nLast modified: " + document.lastModified +
      "\nFrames: " + (frames.length) +
      "\nImages: " + (imO.length - imC) +
      "\nLinks: " + (liO.length - liC) +
      "\nForms: " + (document.forms.length - 1) +
      "\nEmbedded objects: " + document.embeds.length + "\n"
    )
  },

  // Say what should happen when clicking the menu buttons. - JD, sidki
  mlForm : function (aTag) {
    var i, f, all ="", here = window.location, el = aTag.form.elements;
    for (i = 0; f = el[i]; i++)
      if (f.checked && f.value != "i_level:" + prxO.oSet.$_level) all += f.value + ".";
    switch (aTag.value) {
      case "Go" :
        all = all ? "?prx-keyword=." + all : "";
        var query = here.search.match(/^(.*)\?prx-keyword=/);
        query = !query ? here.search : query[1];
        here.href = here.protocol + "//" + here.host + here.pathname +
          query + all + here.hash;
        break;
      case "List" :
        all = all || "YOUR_WORD.";
        var hostR = here.hostname.match(/^https\.\.(.+)/)
        hostR = hostR ? hostR[1] :
          ((here.protocol == "https:" && !here.port) ?
          (here.hostname + ":443") : here.host);
        here.href = "http://add.to.proxlist/" + hostR +
          here.pathname.match(/^\/([^\/]+\/)*/g) +
          "$$$SET(0=" + all + ")$$" + here.href;
        break;
      case "Session" :
        here.href = "http://add.to.memlist/" +
          "$SET(a=" + all + ")PrxFail$TST()$$" + here.href;
    }
  }

};
